#ifndef _MAIN_H
#define _MAIN_H

#include "stm32f4xx.h"
#include <CoOS.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "stm32f4x7_eth_bsp.h"
#include "OsArch.h"

//======================================================================
// Definition global defines
//----------------------------------------------------------------------
#define   RTOS_COOS

#define   OK       (0)
#define   ERROR    (-1)

#define   ON       (!(OFF))
#define   OFF      (0)

#define   MUTEX_INIT(mutex)       static volatile int mutex=0
#define   MUTEX_UNLOCK(mutex)     mutex=0
#ifdef    RTOS_COOS
  #define MUTEX_WAITLOCK(mutex)   do{while(mutex){CoTickDelay(1);}mutex=1;}while(0)
#else
  #define MUTEX_WAITLOCK(mutex)   do{while(mutex);mutex=1;}while(0)
#endif

//======================================================================
// Definition of my favorite types
//----------------------------------------------------------------------
typedef signed char          s08;
typedef signed short         s16;
typedef signed int           s32;
typedef signed long long     s64;
typedef unsigned char        u08;
typedef unsigned short       u16;
typedef unsigned int         u32;
typedef unsigned long long   u64;

/* MAC ADDRESS: MAC_ADDR0:MAC_ADDR1:MAC_ADDR2:MAC_ADDR3:MAC_ADDR4:MAC_ADDR5 */
#define MAC_ADDR0   2
#define MAC_ADDR1   0
#define MAC_ADDR2   0
#define MAC_ADDR3   0
#define MAC_ADDR4   0
#define MAC_ADDR5   0

/*Static IP ADDRESS: IP_ADDR0.IP_ADDR1.IP_ADDR2.IP_ADDR3 */
#define IP_ADDR0   192
#define IP_ADDR1   168
#define IP_ADDR2   0
#define IP_ADDR3   10

/*NETMASK*/
#define NETMASK_ADDR0   255
#define NETMASK_ADDR1   255
#define NETMASK_ADDR2   255
#define NETMASK_ADDR3   0

/*Gateway Address*/
#define GW_ADDR0   192
#define GW_ADDR1   168
#define GW_ADDR2   0
#define GW_ADDR3   1

/* MII and RMII mode selection, for STM324xG-EVAL Board(MB786) RevB ***********/
#define RMII_MODE

#endif // _MAIN_H
